<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { CONTENT_TYPES } from '../../../common/content-types';
import {
  CTA as CallToAction,
  CopyMedia,
  Copy,
  PullQuote,
  Benefits,
  NextStep,
} from '../../../components/common/index.vue';
import {
  FeatureShowcase as PartnersFeatureShowcase,
  PartnersCTA as PartnersCallToAction,
} from '../../../components/partners/index.vue';
import { getClient } from '~/plugins/contentful.js';

import { techPartnerChildrenHelper } from '~/services/partners/technology-partners-children.service';

import {
  SolutionsHero,
  SolutionsResourceCards,
} from '~/components/solutions/index.vue';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: {
    CallToAction,
    PartnersCallToAction,
    PartnersFeatureShowcase,
    CopyMedia,
    Copy,
    PullQuote,
    Benefits,
    SolutionsHero,
    NextStep,
    SolutionsResourceCards,
  },
  nuxtI18n: false,
  async asyncData({ params, error }: any) {
    try {
      const partnerSlug = `partners/technology-partners/${params.partner}`;
      const entries = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': partnerSlug,
        include: 10,
      });

      const { pageContent } = entries.items[0].fields;
      const seoMetadata = entries.items[0].fields.seoMetadata[0].fields;

      const metadata = {
        title: seoMetadata.title,
        description: seoMetadata.description,
        og_title: seoMetadata.title,
        og_description: seoMetadata.description,
      };

      const partner = techPartnerChildrenHelper(pageContent);
      return { partner, metadata };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).metadata, this.$route.path);
  },
});
</script>

<template>
  <div>
    <SlpContainer>
      <PartnersCallToAction :data="partner.hero" />
    </SlpContainer>
    <SlpContainer
      :variant="partner.copy_media.container_variant"
      :class="partner.copy_media.container_class"
    >
      <CopyMedia :data="partner.copy_media.data" />
    </SlpContainer>
    <SlpContainer
      v-for="component in partner.body"
      :key="component.name"
      :variant="component.container_variant"
      :class="component.container_class"
    >
      <component :is="component.name" :data="component.data" />
    </SlpContainer>
    <SlpContainer variant="gradient">
      <NextStep :variant="partner.nextStepsVariant" />
    </SlpContainer>
  </div>
</template>
